package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.DataSyncIn;
import com.sa.ibiz.demo.demo.service.DataSyncInService;
import com.sa.ibiz.demo.demo.service.dto.DataSyncInSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/datasyncin")
public class DataSyncInResource
{
	@Autowired
	private DataSyncInService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<DataSyncIn> remove(@Validated @RequestBody DataSyncIn data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步接收队列[remove]操作发生错误","DataSyncIn",data.getDatasyncinid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<DataSyncIn> checkKey(@Validated @RequestBody DataSyncIn data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步接收队列[checkKey]操作发生错误","DataSyncIn",data.getDatasyncinid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<DataSyncIn> get(@Validated @PathVariable String id){
		DataSyncIn data=new DataSyncIn();
		data.setDatasyncinid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("数据同步接收队列[get]操作发生错误","DataSyncIn",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<DataSyncIn> update(@Validated @RequestBody DataSyncIn data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步接收队列[update]操作发生错误","DataSyncIn",data.getDatasyncinid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<DataSyncIn> create(@Validated @RequestBody DataSyncIn data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步接收队列[create]操作发生错误","DataSyncIn",data.getDatasyncinid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<DataSyncIn> getDraft(@Validated @RequestBody DataSyncIn data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步接收队列[getDraft]操作发生错误","DataSyncIn","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<DataSyncIn>> searchDefaultPage(@Validated @RequestBody DataSyncInSearchFilter filter){
		Page<DataSyncIn> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<DataSyncIn>> listDefault(@Validated @RequestBody DataSyncInSearchFilter filter){
		List<DataSyncIn> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
